/* ctoi.c  93.12.19
 * Copyright 1983-1992   Albert Davis
 * get integer from string
 * update string pointer
 * return integer if got, else 0
 * pointer points to char following number just got
 * or first non-space
 */
#include "ecah.h"
#include "declare.h"
/*--------------------------------------------------------------------------*/
	int ctoi(const char*,int*);
/*--------------------------------------------------------------------------*/
/* ctoi: character input to integer
 * Returns signed integer, or 0 if the string is not a number.
 * Input must be integer: no multipliers, no decimal point.
 * Dot or letter belongs to the next token.
 */
int ctoi(const char *cmd, int *cnt)
{
 int val, sign;

 skipbl(cmd,cnt);

 sign = 1;                    /* sign */
 if (cmd[*cnt]=='+'){
    (*cnt)++;
 }else if (cmd[*cnt]=='-'){
    sign = -1;
    (*cnt)++;
 }

 for (val = 0;  isdigit(cmd[*cnt]);  (*cnt)++)
    val = 10 * val + (cmd[*cnt]-'0');

 skipcom(cmd,cnt);
 return val * sign;
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
