/* d_vcvs.c  94.01.16
 * Copyright 1983-1992   Albert Davis
 * functions for vcvs
 * temporary kluge: it has resistance
 * BUG: doesn't work in incmode
 */
#include "ecah.h"
#include "branch.h"
#include "mode.h"
#include "options.h"
#include "declare.h"
/*--------------------------------------------------------------------------*/
static 	int	tr_vcvs(branch_t*);
static	void	ac_vcvs(branch_t*);
/*--------------------------------------------------------------------------*/
extern const struct options opt;
static branch_t resistor = {(generic_t*)NULL, sizeof(branch_t),
    (functions_t*)NULL, (branch_t*)NULL, (branch_t*)NULL, (branch_t*)NULL,
    (branch_t*)NULL, /*more*/};
/*--------------------------------------------------------------------------*/
functions_t dev_vcvs = {
   (generic_t*)NULL,	/* x */
   sizeof(functions_t),	/* ssize */
   sizeof(branch_t),	/* elementsize */
   (functions_t*)NULL,	/* super */
   4, 			/* numnodes */
   rnTWOPORT,		/* refnode */
   rnTWOPORT,		/* isdevice */
   create_std,		/* create */
   copy_std,		/* copy */
   parse_std,		/* parse */
   print_std,		/* print */
   NULL,		/* expand */
   probe_std,		/* probe */
   tr_vcvs,		/* dotr */
   unloadactive,	/* untr */
   ac_vcvs,		/* doac */
   trfix1,		/* trfun1 */
   trfix0,		/* trfun0 */
   acfix,		/* acfun */
   NULL,		/* tr_guess */
   NULL,		/* tr_advance */
   NULL			/* tr_review */
};
/*--------------------------------------------------------------------------*/
static int tr_vcvs(branch_t *brh)
{
 trsetup(brh);

 resistor.n = brh->n;
 resistor.loaditer = 0;
 resistor.y0.f1 = 1./opt.shortckt;		/* load the resistor */
 resistor.y0.f0 = LINEAR;			/* a big fudge */
 resistor.m0.x  = resistor.y0.x;
 resistor.m0.c0 = 0.;
 resistor.m0.f1 = resistor.y0.f1;
 trloadpassive(&resistor);

						/* then do vccs */
 brh->m0.x = tr_volts_limited(&(brh->n[IN1]),&(brh->n[IN2]));
 brh->y0.x = brh->m0.x;
 if (brh->f->trfun1){
    (*brh->f->trfun1)(brh);
    brh->m0.c0 = (brh->y0.f0 - brh->y0.x * brh->y0.f1) / -opt.shortckt;
 }else{
    brh->y0.f1 = brh->val;
    brh->y0.f0 = brh->y0.x * brh->y0.f1;
    brh->m0.c0 = 0.;
 }
 brh->m0.f1 = brh->y0.f1 / -opt.shortckt;
 trloadactive(brh);
 return brh->converged = conv_check(brh);
}
/*--------------------------------------------------------------------------*/
static void ac_vcvs(branch_t *brh)
{
 brh->acg.x = 1./opt.shortckt;
 brh->acg.y = 0.;
 acloadpassivereal(brh);

 if (brh->f->acfun){
    brh->acbias = dc_volts(&(brh->n[IN1]),&(brh->n[IN2]));
    brh->ev = (*brh->f->acfun)(brh);
    brh->acg.x = brh->ev.x / -opt.shortckt;
    brh->acg.y = brh->ev.y / -opt.shortckt;
 }else{
    brh->ev.x  = brh->y0.f1;
    brh->ev.y  = 0.;
    brh->acg.x = brh->ev.x / -opt.shortckt;
    brh->acg.y = 0.;
 }
 acloadactive(brh);
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
